D4Science Infrastructure - Docker Image #12035
Please deploy a Docker container with the "out of the box" LimeSurvey community version

Jun 26, 2018 11:41 AM - Massimiliano Assante

Status: Closed Start date: Jun 26, 2018

Priority: Urgent Due date: Jun 29, 2018

Assignee: _InfraScience Systems Engineer % Done: 100%

RAM: 2 Display Name: LimeSurvey

DiskSpace: 5 App Description: A container with Limesurvey

(https://www.limesurvey.org/en/) installed
and ready to go

External storage data Container registry cramirez/limesurvey
disk: URL:

Image Name: limesurvey.tar.bz2

Description

In the context of ENVRIPIlus Project we would need (possibly bu the end of this week) to deploy a LimeSurvey community version
which installation comes with a built-in simple web server (port 80 as default)

For version please see:

e https://hub.docker.com/r/crramirez/limesurvey/

History

#1 - Jun 26, 2018 12:33 PM - Andrea Dell'Amico

- Container registry URL set to cramirez/limesurvey

Do we need any persistent storage?

#2 - Jun 26, 2018 12:34 PM - Massimiliano Assante

Andrea Dell'’Amico wrote:

Do we need any persistent storage?

Of course we do, the created surveys must stay

#3 - Jun 26, 2018 12:50 PM - Maggie Hellstrom
Well, to me this is a bit complicated to understand how you want to:
e deal with the LimeSurvey installation as such, since it comes with its own built-in database and storage (for both the surveys, the questions, and
the responses)
e couple the LimeSurvey results database to the ENVRIplus Service Portfolio catalogue - | suggested initially to, for each individual service being

evaluated, extract important results and/or statistics from LimeSurvey and store this in the portfolio catalogue (together with the other information
in there), but | understood from Massi that this wasn't necessary or even desirable.

Now, I'm happy to leave these issues to you experts, but | would like to make sure that no information is lost if, for example, the LimeSurvey
installation would fail catastrophically for whatever reason. A lot of information could be lost, or at least be difficult to retrieve from backups.

#4 - Jun 26, 2018 02:19 PM - Andrea Dell'Amico

| was asking because nothing was specified in the request, but the container image runs a mysql instance and saves the surveys locally. I'll provide
an external storage for both mysql and the surveys.

#5 - Jul 02, 2018 06:42 PM - Andrea Dell'Amico
- Status changed from New to In Progress

- % Done changed from 0 to 40

I'm trying to run the container giving it a different location, because the docker server is shared with other containers, but it's not working. The option
is listed in the container documentation https://hub.docker.com/r/crramirez/limesurvey/ but it's not effective. | started the container with the command
docker run -d --name limesurvey -p 8082:80 -e HTTP_LOCATION="limesurvey" -v limesurvey_mysqgl:/var/lib/mysql -v
limesurvey_data:/app/upload crramirez/limesurvey:latest

But the accesses to https://docker-exec1.d4science.org/limesurvey/ are redirected to / (
https://docker-exec1.d4science.org/index.php?r=installer/welcome )
| see from the logs that the container starts correctly, but the environment variable is ignored.

#6 - Jul 02, 2018 06:55 PM - Andrea Dell'Amico

| see that the variable is been passed to the container. The output of docker container inspect limesurvey reports

"Env": [
"HTTP_LOCATION=limesurvey",
"PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin",
"DEBIAN_FRONTEND=noninteractive",
"PHP_UPLOAD_MAX_FILESIZE=10M",
"PHP_POST_MAX_SIZE=10M"

1,

But still it seems that the application does not honour it.

@margareta.hellstrom@nateko.lu.se Any hints? Did you run the container with a similar configuration?

#7 - Jul 02, 2018 07:10 PM - Andrea Dell'Amico

Manually fixing all the redirections | am able to reach https:/docker-execi.d4science.org/limesurvey/index.php?r=installer/welcome that presents the
installation page, but going further is not possible.

#8 - Jul 02, 2018 11:53 PM - Andrea Dell'Amico

Never mind, it was my fault. The application is reachable. @massimiliano.assante@isti.cnr.it the docker server is currently configured to be accessed
by the infra gateway only. Do you plan to make the application reachable through the portal, or do | need to open the https port to the world?

#9 - Jul 03, 2018 08:05 AM - Massimiliano Assante
Andrea Dell'’Amico wrote:
Never mind, it was my fault. The application is reachable. @massimiliano.assante@isti.cnr.it the docker server is currently configured to be

accessed by the infra gateway only. Do you plan to make the application reachable through the portal, or do | need to open the https port to the
world?

Margareta and her colleagues need to access via http(s) and as LimeWire Administrator users.

#10 - Jul 03, 2018 10:02 AM - Maggie Hellstrom

Thank you Andrea for all your hard work! Sorry for not replying sooner, but | see from the recent messages that the issue you had earlier now seems
to have been sorted out. As for access, yes | and my colleagues in ENVRIplus WP9 need to be able to access both the installation's administrative
interface, and any surveys that we create, directly from the outside via the corresponding URLSs - | believe all of these use https protocol. Later, we
would like to integrate the surveys we have created with the ENVRIplus service catalogue by giving users the possibility to run surveys by clicking on
a link, which would then open a page in their browser. Cheers, Maggie

#11 - Jul 03, 2018 12:18 PM - Andrea Dell'Amico

- Assignee changed from _InfraScience Systems Engineer to Maggie Hellstrém

Thanks for the clarifications. The application is now reachable from anywhere at https:/docker-exec1.d4science.org/limesurvey/, please configure it
as soon as you can because right now if someone discovers the URL can mess with it.

#12 - Jul 03, 2018 12:19 PM - Andrea Dell'Amico

- Status changed from In Progress to Feedback

- % Done changed from 40 to 100

#13 - Jul 03, 2018 01:59 PM - Maggie Hellstrom

Dear all,

Together with my colleague Claudio, | have now successfully configured the LimeSurvey installation. As a result, following the link you sent earlier
now results in the visitor arriving at a welcome page, rather than the setup dialogue. Please let me know if you would like me to set up a user account

for anybody from your group, and if you require any other information.

I've only found one technical issue so far, in that it seems that the LimeSurvey installation lacks the possibility to send e-mails - probably because the
OS inside the Docker isn't set up to allow that?
This is somewhat limiting as for example new users added to the system aren't notified, but | can live with that for now. However, as the system
becomes operational, it will be necessary to allow messages to be sent to users - for example to invite them to take surveys, or to send summaries of
responses after people complete a survey. So | hope this doesn't constitute a huge security issue for you and that the capability to send emails can
be eventually added.

Anyway, we'll start testing the installation in the coming weeks, adding a few test surveys and preparing the groundwork for the "real" service
evaluation application - but because of the summer holidays there probably won't be too much done until early August.

#14 - Jul 03, 2018 02:59 PM - Leonardo Candela
- Status changed from Feedback to Closed

I'm going to close this ticket since the deployment of the technology is done. I'm going to open a follow up ticket to discuss the integration of this
technology with the rest.

#16 - Jul 04, 2018 01:54 PM - Andrea Dell'Amico
- Status changed from Closed to In Progress

- Assignee changed from Maggie Hellstrém to _InfraScience Systems Engineer

Maggie Hellstrom wrote:
Dear all,

I've only found one technical issue so far, in that it seems that the LimeSurvey installation lacks the possibility to send e-mails - probably
because the OS inside the Docker isn't set up to allow that?

Yes, we never allow sending email if not explicitly requested.
What options do you have from the application? | can setup a username/password to talk with our internal relay, you have to support TLS as a
transport, on port 587.

Is it OK for you?

#17 - Jul 04, 2018 02:13 PM - Maggie Hellstrom

Dear Andrea,

| don't know at the moment how the LimeSurvey application inside the Docker is configured. | have to talk to my colleagues here in Lund, but some of
them are already on vacation. I'll see if | can get a fast answer, otherwise it's fine to wait until after the summer break.

Is there some way that we can access the Docker itself, and log in to it directly? Such access could be very helpful when trying to identify the best
way to set up the mailing-related parameters. In addition, we are likely to write some customized plug-ins for the LimeSurvey installation (to enhance
the built-in statistics and reporting modules). Implementing these would also benefit from being able to modifying the Docker contents directly.

#18 - Jul 04, 2018 02:50 PM - Andrea Dell'Amico

Maggie Hellstrém wrote:
Dear Andrea,

| don't know at the moment how the LimeSurvey application inside the Docker is configured. | have to talk to my colleagues here in Lund, but
some of them are already on vacation. I'll see if | can get a fast answer, otherwise it's fine to wait until after the summer break.

Is there some way that we can access the Docker itself, and log in to it directly?

No I'm sorry, but the only way would be giving you access to the docker servers as docker user, to permit you to open a shell inside the container. But
that way you would have access to the docker service and all the running containers.

Such access could be very helpful when trying to identify the best way to set up the mailing-related parameters. In addition, we are likely to write
some customized plug-ins for the LimeSurvey installation (to enhance the built-in statistics and reporting modules). Implementing these would
also benefit from being able to modifying the Docker contents directly.

Well, that's the opposite of how containers are supposed to work. It would be better creating a new image starting from the original one, so that the
modifications aren't lost after an upgrade.

#19 - Jul 05, 2018 01:27 PM - Maggie Hellstrom

We seem to have been able to solve the issue with the mail sending capability: my colleague Claudio has set up a dedicated gmail account (
envriCommunity@gmail.com), and configured the LimeSurvey installation so that it uses Gmail (smtp.gmail.com:587) to send administrative emails
from the system. We have run some tests, and it seems to work fine. | hope there won't be any firewall issues or similar preventing this workaround.
Have a nice summer!
#20 - Jul 05, 2018 01:33 PM - Massimiliano Assante

- Status changed from In Progress to Closed

This is excellent news! Thanks everyone
